# Purr - Password Generation and Sharing
![Big Purr and Sploot](https://eversole.co/Purr-Small.png "Purr!")  
Purr is a work-in-progress web application offering customizable password generation and time-limited link sharing features.

## What problems does Purr solve?
1. Generating sufficiently memorable but secure passwords for use with accounts that don't offer better authentication methods.
2. Sharing passwords or other text secrets with others via email/chat/etc., without disclosing the password itself. As passwords expire after a predefined period, the email/chat history where the information was shared don't become a purr-manent (sorry, **permanent**) vulnerability.
3. Being really cute compared to the competition.

## Tech Stack?
1. [Haskell](https://www.haskell.org) and [Scotty](https://github.com/scotty-web/scotty) backend.
2. [HTMX](https://github.com/bigskysoftware/htmx) and [Alpine.js](https://github.com/alpinejs/alpine) for the frontend.
3. [MongoDB](https://github.com/mongodb/mongo) database.

## Why should I trust you with my passwords?
You shouldn't! This is free and open-source software which you can run on your own hardware. Instructions for deployment are coming soon.

## Development & Support
Please send me an [email](mailto:james@eversole.co) or join the [Support Chat](openpgp4fpr://FEB27223219E8DB3203225350462EA0901FE08F7#a=james%40eversole.co&g=Purr%20Support&x=RbVs8iQCVnf&i=-FuzUDK_RM1&s=KgeGtFFJtkq) in [DeltaChat](https://delta.chat)!  
![Join Purr DeltaChat Group - QR Code](https://eversole.co/PurrSupport.png "Purr Support QR Code!")

Copyright (C) 2022-2022 [James Eversole](https://eversole.co)
