module Core.Mongo ( mongoSetup, tempGetDocs ) where

import Core.Types

import Control.Monad.Reader (MonadIO)
import Database.MongoDB
import Prelude

mongoSetup :: DhallConfig -> IO MongoContext
mongoSetup conf = do
  mongoCon <- connect $ host (hostname conf)
  let adminCon = MongoContext mongoCon master (adminDB conf)
  access (mongoPipe adminCon) (mongoAccessMode adminCon) (mongoDatabase adminCon) (auth (mongoUsername conf) (mongoPassword conf))
  return $ MongoContext mongoCon master (dataDB conf)

tempGetDocs :: MonadIO m => AppConfig -> m [Document]
tempGetDocs appConfig = access (mongoPipe db) (mongoAccessMode db) (mongoDatabase db) $ find (select [] (collection conf)) >>= rest
  where
    db   = dbconn appConfig
    conf = res appConfig
