module Core.Types where

import qualified Data.Text.Lazy as LT

import Control.Monad.Reader (MonadIO, MonadReader, ReaderT)
import Data.Text
import Database.MongoDB     (MongoContext)
import GHC.Generics         (Generic)
import Numeric.Natural      (Natural)
import Web.Scotty.Trans     (ScottyT, ActionT)

type PurrApp    a = ScottyT LT.Text ConfigM a
type PurrAction a = ActionT LT.Text ConfigM a

newtype ConfigM a = ConfigM
  { runConfigM :: ReaderT AppConfig IO a
  } deriving (Applicative, Functor, Monad, MonadIO, MonadReader AppConfig)

data AppConfig = AppConfig
  { res    :: DhallConfig
  , dbconn :: MongoContext
  }

data DhallConfig = DhallConfig
  { hostname      :: String
  , port          :: Int
  , environment   :: Text
  , adminDB       :: Text
  , dataDB        :: Text
  , collection    :: Text
  , mongoUsername :: Text
  , mongoPassword :: Text
  } deriving (Generic, Show)

